<?php

namespace Modules\Qc\Http\Controllers;

use Exception;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Routing\Controller;
use Modules\Qc\Entities\DamageCheckingRecordsHeader;
use Modules\Qc\Entities\DamageCheckingRecordsData;
use Modules\Pp\Entities\CustomerOrderPlansData;
use Modules\Pp\Entities\MachineryPlans;
use Modules\Hr\Entities\AttShift;

class DamageCheckingRecordsDataController extends Controller
{
    public function save(Request $request)
    {
        try {
            $rec = new DamageCheckingRecordsHeader();
            $rec->customer_order_plan_data_id = $request->get('customer_order_plan_data_id');
            $rec->product_primary_id = $request->get('product_primary_id');
            $rec->trans_date_time = $request->get('trans_date_time');
            if ($rec->save()) {
                $rec_arr = $request->get("dc_data");
                for ($i = 0; $i < count($rec_arr); $i++) {
                    $dcData = json_decode($rec_arr[$i]);

                    $rec_data = new DamageCheckingRecordsData();
                    $rec_data->dcr_id = $rec->dcr_id;
                    $rec_data->date = $dcData->date;
                    $rec_data->shift_id = $dcData->shift_id;
                    $rec_data->hour = $dcData->hour;
                    $rec_data->seal_damage = $dcData->seal_damage;
                    $rec_data->block_damage = $dcData->block_damage;
                    $rec_data->slab_damage = $dcData->slab_damage;
                    $rec_data->print_damage = $dcData->print_damage;
                    $rec_data->packing_damage = $dcData->packing_damage;
                    $rec_data->other_damage = $dcData->other_damage;
                    $rec_data->qc_seal_damage = $dcData->qc_seal_damage;
                    $rec_data->qc_block_damage = $dcData->qc_block_damage;
                    $rec_data->qc_slab_damage = $dcData->qc_slab_damage;
                    $rec_data->qc_print_damage = $dcData->qc_print_damage;
                    $rec_data->qc_packing_damage = $dcData->qc_packing_damage;
                    $rec_data->qc_other_damage = $dcData->qc_other_damage;

                    $rec_data->save();
                }
            }
            $responseBody = $this->responseBody(true, "DamageCheckingRecordsDataController", "saved", true);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "DamageCheckingRecordsDataController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }

    public function update(Request $request, $id)
    {

        try {

            if ($this->delete($id)) {
                $rec = DamageCheckingRecordsHeader::find($id);
                $rec->customer_order_plan_data_id = $request->get('customer_order_plan_data_id');
                $rec->product_primary_id = $request->get('product_primary_id');
                $rec->trans_date_time = $request->get('trans_date_time');
                $rec->update();

                $rec_arr = $request->get("dc_data");
                if ($rec_arr) {
                    for ($i = 0; $i < count($rec_arr); $i++) {
                        $dcData = json_decode($rec_arr[$i]);
                        $rec_data = new DamageCheckingRecordsData();
                        $rec_data->dcr_id = $rec->dcr_id;
                        $rec_data->date = $dcData->date;
                        $rec_data->shift_id = $dcData->shift_id;
                        $rec_data->hour = $dcData->hour;
                        $rec_data->seal_damage = $dcData->seal_damage;
                        $rec_data->block_damage = $dcData->block_damage;
                        $rec_data->slab_damage = $dcData->slab_damage;
                        $rec_data->print_damage = $dcData->print_damage;
                        $rec_data->packing_damage = $dcData->packing_damage;
                        $rec_data->other_damage = $dcData->other_damage;
                        $rec_data->qc_seal_damage = $dcData->qc_seal_damage;
                        $rec_data->qc_block_damage = $dcData->qc_block_damage;
                        $rec_data->qc_slab_damage = $dcData->qc_slab_damage;
                        $rec_data->qc_print_damage = $dcData->qc_print_damage;
                        $rec_data->qc_packing_damage = $dcData->qc_packing_damage;
                        $rec_data->qc_other_damage = $dcData->qc_other_damage;
                        $rec_data->save();
                    }
                }
            }

            $responseBody = $this->responseBody(true, "DamageCheckingRecordsHeaderController", "update", true);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "DamageCheckingRecordsHeaderController", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }

    public function delete($id)
    {
        try {
            $rec_data = DamageCheckingRecordsData::where('dcr_id', '=', $id)->get();
            foreach ($rec_data as $data) {
                $data->delete();
            }
            return true;
        } catch (Exception $exception) {
            return false;
        }
    }


    public function getShiftData()
    {
        try {
            $shift =  AttShift::all();
            $responseBody = $this->responseBody(true, "DamageCheckingRecordsDataController", "getShiftData", $shift);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "DamageCheckingRecordsDataController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }

    public function getDcData($id)
    {
        try {
            $recordHead = DamageCheckingRecordsHeader::find($id);
            $recordData = DamageCheckingRecordsData::where('dcr_id', '=', $id)->get();

                foreach ($recordData as $data) {
                    $total = $data->seal_damage + $data->block_damage + $data->slab_damage + $data->print_damage + $data->packing_damage + $data->other_damage;
                    $qc_total = $data->qc_seal_damage + $data->qc_block_damage + $data->qc_slab_damage + $data->qc_print_damage + $data->qc_packing_damage + $data->qc_other_damage;
                    $data->total = $total;
                    $data->qc_total = $qc_total;
                }

            $recordHead->request_data = $recordData;

            $responseBody = $this->responseBody(true, "DamageCheckingRecordsDataController", "getDcData", $recordHead);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "DamageCheckingRecordsDataController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }








     /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
